// Argeniss - Information Security
//  www.argeniss.com
//
// Database Backdoor Console (Proof-of-concept Beta Version)
// 
// Author: Esteban Martinez Fayo (esteban>.at.<argeniss>.dot.<com)

using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;

namespace DBBackdoorConsole
{
    public class BackdoorCommand
    {
        /// <summary>
        /// A descriptive name for the Backdoor Command
        /// </summary>
        private string m_Name;

        /// <summary>
        /// A descriptive name for the Backdoor Command
        /// </summary>
        public string Name
        {
            get { return m_Name; }
        }
        private string m_SQLText;
        
        /// <summary>
        /// Database type, can be "Oracle" or "SQL Server"
        /// </summary>
        private string m_DBType;
        
        private List<string> m_ParametersName = new List<string>();
        
        private List<string> m_ParametersValue = new List<string>();

        private TextBox m_txtSQLTextToExec;
        
        private FlowLayoutPanel m_ParametersFlow;

        
        public BackdoorCommand(string p_Name, string p_DBType, string p_SQLText, TextBox txtSQLTextToExec)
        {
            m_Name = p_Name;
            m_DBType = p_DBType;
            m_SQLText = p_SQLText;
            m_txtSQLTextToExec = txtSQLTextToExec;
            SetParameters(m_SQLText);
        }


        private void SetParameters(string SQLText)
        {
            int StartPos = SQLText.IndexOf("{{");
            int EndPost = SQLText.IndexOf("}}");
            string sStr;
            string[] saStr;

            m_ParametersName.Clear();
            m_ParametersValue.Clear();

            while(StartPos > 0 && EndPost > 0)
            {
                sStr = SQLText.Substring(StartPos + 2, EndPost - StartPos - 2);
                saStr = sStr.Split('=');

                if (!m_ParametersName.Exists(delegate(string s) { return s == saStr[0]; }))
                {
                    if (saStr.Length >= 1)
                        m_ParametersName.Add(saStr[0]);
                    else
                        m_ParametersName.Add("");

                    if (saStr.Length >= 2)
                        m_ParametersValue.Add(saStr[1]);
                    else
                        m_ParametersValue.Add("");
                }

                StartPos = SQLText.IndexOf("{{", StartPos + 1);
                EndPost = SQLText.IndexOf("}}", EndPost + 1);
            }
        }
       

        private void txtParameterValue_TextChanged(object sender, EventArgs e)
        {
            if (m_txtSQLTextToExec != null && m_ParametersFlow != null)
                m_txtSQLTextToExec.Text = GetSQLTextToExec(m_ParametersFlow);
        }


        public void FillParameterControls(FlowLayoutPanel flow)
        {
            flow.Controls.Clear();
            m_ParametersFlow = flow;
            m_txtSQLTextToExec.Text = m_SQLText;
            if (m_ParametersName.Count == m_ParametersValue.Count)
            {
                for (int i = 0; i < m_ParametersName.Count; i++)
                {
                    Label l = new Label();
                    TextBox t = new TextBox();

                    l.Text = m_ParametersName[i];
                    l.AutoSize = true;
                    t.Text = m_ParametersValue[i];
                    t.TextChanged += new System.EventHandler(this.txtParameterValue_TextChanged);

                    flow.Controls.Add(l);
                    flow.Controls.Add(t);
                }
            }
        }


        public string GetSQLTextToExec(FlowLayoutPanel flow)
        {
            string SQLTextToExec = m_SQLText;

            if (m_ParametersName.Count == m_ParametersValue.Count && flow.Controls.Count / 2 == m_ParametersName.Count)
            {
                for (int i = 0; i < m_ParametersName.Count; i++)
                    SQLTextToExec = SQLTextToExec.Replace("{{" + m_ParametersName[i] + "=" + m_ParametersValue[i] + "}}", flow.Controls[i*2+1].Text);
            }
            return SQLTextToExec;
        }
    }
}
